/*
 * Main.java
 *
 * Created on 21. listopad 2006, 19:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package osmdam;

import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Set;
import java.util.TreeSet;

/**
 *
 * @author pirko
 */
public class Main {
    
    private Set<State> history = new TreeSet<State>(new Comparator() {
         public int compare(Object state1, Object state2) {
            if (state1 == null) return Integer.MAX_VALUE;
            if (state2 == null) return Integer.MIN_VALUE;
            return state1.equals(state2) ? 0 : -1;
        }
    });
    private Queue<StateNode> queue = new LinkedList<StateNode>();
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        System.out.println("\nZe zadani:");
        Main main = new Main();
        main.minConflict(new State(State.Type.DEFAULT)); // defaultni ze zadani
        
        System.out.println("\nTri konflikty:");
        Main soft = new Main();
        soft.minConflict(new State(State.Type.SOFT));
        
        // Nasledujici radky je mozne odkomentovat pro vyzkouseni velmi texkeho zadani
        
//        System.out.println("\nNejtezsi:");
//        Main hard = new Main();
//        hard.minConflict(new State(State.Type.HARD)); // njtezsi
        
    }
    
    public void minConflict(State start) {
        history.add(start);
        queue.offer(new StateNode(start,null));
        
        System.out.println("STARTING min-conflict:");
        start.print();
        System.out.print("\n");
       
        boolean finished = false;
        StateNode node;
        
        do {
            node = queue.poll();
            if (node == null) 
                break; // dosli jsme nakonec fronty a nemame reseni!!!
            
            
            // test na reseni
            finished = node.getState().isSolution();
            if (finished) {
                System.out.println("Mame reseni:");
                node.getState().print();
                System.out.println("hloubka: "+node.getDeep());
                break;
            } 
            
            // expanduj
            List<State> nexts = node.getState().getNext();
            for (State s : nexts) {
                if (!history.contains(s)) {
                    history.add(s);
                    queue.offer(new StateNode(s,node));
                }
            }
        } while(node != null);
    }
    
}
